Subject: Re: GCC for Windows help
From: "Garfield Lewis" <[email-masked]>
To: [email-masked]
Cc: [email-masked]
Date: Fri, 9 May 2003 09:06:12 -0400

Hi Larry,

Thx, for you suggestions...

The --enable-auto-image-base does a good enough job of giving me an address
that is high enough to be out of the way of most dlls. However, there is
still the possibility of failure if something else gets loaded there first.
And I really wouldn't want to try to rebase every dll on my system.

Thx,

Garfield A. Lewis
<mailto:[email-masked]>
DB2 UDB Development                    (905) 413-3438  T/L: 969-3438
Intranet
<http://w3.torolab.ibm.com/~garfield/garfield.html>
External E-mail
<mailto:[email-masked]>
IBM SWS Toronto Laboratory

|---------+---------------------------->
|         |           Larry Hall       |
|         |           <[email-masked]>  |
|         |                            |
|         |           05/08/2003 10:21 |
|         |           PM               |
|         |           Please respond to|
|         |           lhall            |
|         |                            |
|---------+---------------------------->
  >------------------------------------------------------------------------------------------------------------------------------|
  |                                                                                                                              |
  |       To:       Garfield Lewis/Toronto/IBM@IBMCA                                                                             |
  |       cc:       [email-masked]                                                                                            |
  |       Subject:  Re: GCC for Windows help                                                                                     |
  |                                                                                                                              |
  |                                                                                                                              |
  >------------------------------------------------------------------------------------------------------------------------------|

Hi Garfield,

Depends on the context.  Rebaseall will rebase all the DLLs installed
by setup.exe.  You could certainly add to that list to encompass other
DLLs too.  But perhaps that's side-stepping the issue.  However, as a
practical stop-gap measure, it should work.

Larry

Garfield Lewis wrote:
> Hi Larry,
>
> Rebase will not help because the relocations are gone so irregardless of
> what the base address is if I cannot get that address the load will fail
> instead of just loading somewhere else and fixing up the addresses.
>
> Thx,
>

<snip>

>
>
> Garfield Lewis wrote:
>
> <snip>
>
>>On 8 May 2003 at 14:39, "Garfield Lewis" <[email-masked]> wrote:
>>
>>
>>>Yes, been there done that... The problem is not building the dll it's
>>>running it. Since their linker strips the relocations out of the dll
then
>>>if the dll is loaded by any proces that happens to not have the
preferred
>>>address free then the dll will not load because cannot fixup the address
>>>within the dll. It is a stupid default for Windows but seems to be the
>>
>>case
>>
>>
>>>here. The --emit-relocs option seems to be what I need, however, so far
>>
>>all
>>
>>
>>>my info indicates that this only works for ELF binaries. Using the
>>>---enable-auto-image-base is a workaround for now because it chooses an
>>>address other than 0x10000000 as the preferred load address but it to
>>
>>will
>>
>>
>>>fail if the above happens, however less likely.
>
>
>
> Sounds like something that the rebase package could help you with...
>
> --
>
> Larry Hall                              http://www.rfk.com
> RFK Partners, Inc.                      (508) 893-9779 - RFK Office
> 838 Washington Street                   (508) 893-9889 - FAX
> Holliston, MA 01746
>
>
>
>
>
> --
> Unsubscribe info:      http://cygwin.com/ml/#unsubscribe-simple
> Problem reports:       http://cygwin.com/problems.html
> Documentation:         http://cygwin.com/docs.html
> FAQ:                   http://cygwin.com/faq/
>
>

--
Larry

--
Unsubscribe info:      http://cygwin.com/ml/#unsubscribe-simple
Problem reports:       http://cygwin.com/problems.html
Documentation:         http://cygwin.com/docs.html
FAQ:                   http://cygwin.com/faq/